//
//  ChocoLayerText.h
//  ChocoFlopX
//
//  Created by Santiago Lema on 06.11.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "ChocoLayer.h"

@interface ChocoLayerText : ChocoLayer 
{
	CIImageAccumulator* accuTextRendered;
	CGRect textFrame;
	BOOL textChanged;
	CGRect previousTextVisibleRect;

	NSImage* pdfImage;
	NSTextView* textView;
	NSTextView* textViewClone;
	NSLock* modifyTextImageLock;
	NSLock* renderTextLock;
	NSLock* lockTextViewSize;
	

	BOOL autolabel;
	NSRect textBoundsBeforeDrag;

		

}

-(void) setAutolabel:(BOOL)a;
-(BOOL) getAutolabel;

-(void) setTextBoundsBeforeDrag:(NSRect)r;
-(NSRect) getTextBoundsBeforeDrag;

-(void) setTextView:(NSTextView*)v;
-(IBAction) restoreTextView:(NSTextView*) v;
-(NSTextView*) getTextView;
-(void) setTextData:(NSData*) rtfData;
-(NSData*) getTextData ;
-(IBAction) restoreTextData:(NSData*) rtfData;
-(void) createEmptyTextAtPoint:(NSPoint)pt withWidth:(float)w andHeight:(float)h render:(BOOL) render;
-(CIImage*) getTextAsImage	;
-(void) textNeedsRender;
-(void) updateTextRenderedNOW;

-(void) updateLabelFromTextView;
-(BOOL)isPointInsideText:(NSPoint) pt;
-(void)loadRTFfromPath: (NSString*) txtPath renderImmediately:(BOOL)immediateRender createTextView:(BOOL)createView;
-(void) setTextViewSizeToWidth:(int) maxX andHeight:(int) maxY;
//-(void)convertToPixels;

-(NSRect) getTextViewBounds;
-(CIImageAccumulator*) getTextAccu;

-(NSTextView*) allocTextViewWithCorrectSettingsInFrame:(NSRect)rView;

-(void) createCloneOfTextView:(NSTextView*)v prerenderedAccu:(CIImageAccumulator*) accuClone;
-(void) textContentChanged;

@end
